package("readerwritercircularbuffer")

set_kind("library")
set_homepage("https://github.com/cameron314/readerwriterqueue")

set_urls("https://github.com/cameron314/readerwriterqueue/archive/$(version).zip")
add_versions("16b48ae1148284e7b40abf72167206a4390a4592", "11758ab1b2ec96217245b32222edbcae76b686c9d795973907223ce0b720541f")

add_deps("cmake")

on_install(function (package)
    local configs = {}
    table.insert(configs, "-DCMAKE_BUILD_TYPE=" .. (package:debug() and "Debug" or "Release"))
    table.insert(configs, "-DBUILD_SHARED_LIBS=" .. (package:config("shared") and "ON" or "OFF"))
    import("package.tools.cmake").install(package, configs)
end)

on_test(function (package)
    assert(package:has_cxxtypes(
      "BlockingReaderWriterCircularBuffer",
      {includes = "readerwritercircularbuffer.h"}))
end)