/**
 * @file BaseDeviceSource.hh
 * @author 吴晨
 * @brief 适配 live555
 * 
 * @copyright Copyright (c) 2022-2024 OurEDA
 */

#ifndef _BASE_DEVICE_SOURCE_HH
#define _BASE_DEVICE_SOURCE_HH

#include "isp/eb3516_video.h"

using FrameData = video_packet_t;

class BaseDeviceSource {
public:
    virtual codec_type_t getCodecType() = 0;
    virtual void signalNewFrame(const FrameData &frameData) = 0;
};

#endif
