/**
 * @file H26XDeviceSource.hh
 * @author 吴晨
 * @brief 适配 live555
 * 
 * @copyright Copyright (c) 2022-2024 OurEDA
 */

#ifndef _H26X_DEVICE_SOURCE_HH
#define _H26X_DEVICE_SOURCE_HH

#include "FramedSource.hh"
#include "readerwritercircularbuffer.h"

#include "BaseDeviceSource.hh"

class H26XDeviceSource : public FramedSource, public BaseDeviceSource {
public:
    static H26XDeviceSource *createNew(UsageEnvironment &env, Boolean isH265);

public:
    virtual codec_type_t getCodecType();
    virtual void signalNewFrame(const FrameData &frameData);

protected:
    H26XDeviceSource(UsageEnvironment &env, Boolean isH265);
    virtual ~H26XDeviceSource();
    virtual unsigned maxFrameSize() const;
    virtual void doGetNextFrame();

private:
    void deliverFrame();

private:
    Boolean isH265;
    moodycamel::BlockingReaderWriterCircularBuffer<FrameData> frameDataQueue;
    static unsigned referenceCount;
    static EventTriggerId eventTriggerId;
};

#endif
