add_rules("mode.debug", "mode.release")
includes("Hi3516_SDK.lua", "live555.lua", " readerwriterqueue.lua")

--- Add Cross Compile Toolchain
toolchain("arm-himix200-linux")
set_kind("standalone")

set_sdkdir(path.join(os.projectdir(), "arm-himix200-linux"))
toolchain_end()

--- Set toolchain and C/C++ standard
-- set_config("sdk", "/opt/hisi-linux/x86-arm/arm-himix200-linux/")
set_toolchains("arm-himix200-linux")
set_plat("cross")
set_arch("arm")
set_languages("c11", "c++14")

--- Add requires and dependencies
add_requires(
  "zlog 1.2.17",
  "mongoose 7.15",
  "live555 2024.11.28",
  "readerwriterqueue 16b48ae1148284e7b40abf72167206a4390a4592",
  { system = false }
)

target("ISP")
set_kind("static")
add_files("src/modules/isp/*.c")
add_includedirs("src", "src/modules")
add_deps("sample_common")
add_packages("zlog")
target_end()

target("NNIE")
set_kind("static")
add_files("src/modules/nnie/*.c")
add_includedirs("src", "src/modules")
add_deps("sample_common", "sample_svp")
add_packages("zlog")
target_end()

target("RTSP")
set_kind("static")
add_files("src/modules/rtsp/*.cpp")
add_includedirs("src", "src/modules")
add_packages("live555", "zlog", "readerwriterqueue")
add_links("pthread")
target_end()

target("CatFeeder")
set_kind("binary")
add_includedirs("src")
add_files("src/*.cpp")
add_deps("hi_library", "ISP", "NNIE", "RTSP")
add_packages("zlog")
add_links("stdc++fs")
after_build(function(target)
  os.cp("src/log.conf", "$(buildir)/cross/arm/release")
end)

if is_mode("debug") then
  add_defines("DEBUG")
  set_symbols("debug")
  set_optimize("none")
end
target_end()
